package com.ogow.adapter.itemview

import android.os.Bundle
import android.view.View
import android.widget.TextView
import com.facebook.drawee.view.SimpleDraweeView
import com.google.gson.Gson
import com.ogow.activity.R
import com.ogow.core.arouter.module.app.AppService
import com.ogow.core.arouter.router.ServiceManager
import com.ogow.lib.list.base.BaseViewHolder
import com.ogow.lib.list.base.Item
import com.ogow.libs.utils.drawable.GradientDrawableHelper
import com.ogow.libs.utils.image.ImageUtils
import com.ogow.request.entity.CollectionBean
import java.util.*

/**
 * @author qzp
 * @date 2018/1/5 0005.
 */
class CollectShopViewHolder(itemView : View) : BaseViewHolder(itemView) , View.OnClickListener{

    private var ivImg : SimpleDraweeView = mParentView.findViewById(R.id.iv_img) as SimpleDraweeView
    private var tvTitle : TextView = mParentView.findViewById(R.id.tv_title) as TextView
    private var actionGo : TextView = mParentView.findViewById(R.id.action_go) as TextView
    private var textTip : TextView = mParentView.findViewById(R.id.textTip) as TextView

    lateinit var mData : CollectionBean

    init {

        actionGo.setOnClickListener(this)
        mParentView.setOnClickListener(this)

        GradientDrawableHelper.getInstance()
                .setStrokeColor(R.color.orange)
                .setStrokeWidth(1)
                .setPaddingVertical(4)
                .setPaddingHorizontal(8)
                .setRoundRadius(2)
                .genarete(actionGo)
    }

    override fun setItem(item: Item?) {
        if( item != null) {
            mData = item.obj as CollectionBean

            if ( mData.store != null ) {
                ImageUtils.getInstance().load(ivImg, mData.store.store_icon)

                tvTitle.text = mData.store.store_name

                when (mData.flagship) {
                    1 -> textTip.visibility = View.VISIBLE
                    else -> textTip.visibility = View.GONE
                }
            }
        }
    }

    override fun onClick(v: View?) {
        if (!mData.seller_id.isNullOrBlank()) {
            if ( mData.flagship == 1 ) {
                ServiceManager.getInstance().homeProvider.jumpBrandIndex(mData.seller_id)
            } else {
                val b = Bundle()
                if( mData.store != null ) {
                    b.putString("detail", mData.store.store_name )
                }
                b.putString("url", "storeinfo.html")
                val params = HashMap<String, String>()
                params.put("id", mData.seller_id)
                b.putString("param", Gson().toJson(params))
                AppService.jumpLocalH5(b)
            }
        }
    }

}