package com.ogow.christmas.viewholder

import android.text.TextUtils
import android.view.View
import android.widget.ImageView
import android.widget.TextView
import com.facebook.drawee.view.SimpleDraweeView
import com.ogow.activity.R
import com.ogow.lib.list.base.BaseViewHolder
import com.ogow.lib.list.base.Item
import com.ogow.christmas.dialog.PromtDialog
import com.ogow.christmas.rpd.RpdSign
import com.ogow.christmas.rpd.TaskItemBean
import com.ogow.core.https.entity.RbEntity
import com.ogow.basic.utils.event.OgowEvent
import com.ogow.core.https.MyRequest
import com.ogow.core.https.interfaces.IRespondMsg
import com.ogow.libs.utils.image.ImageUtils
import com.ogow.utility.JumpUtils
import org.greenrobot.eventbus.EventBus
import java.util.*


/**
 * @author qzp
 * @date 2018/1/2 0002
 */
class VHTaskItem(itemView: View): BaseViewHolder(itemView) {

    private var actionTask : ImageView = mParentView.findViewById(R.id.action_task) as ImageView
    private var txtTaskName : TextView = mParentView.findViewById(R.id.txt_task_name) as TextView
    private var txtTaskDes: TextView = mParentView.findViewById(R.id.txt_task_des) as TextView
    private var txtTaskProgress: TextView = mParentView.findViewById(R.id.txt_task_progress) as TextView
    private var actionHelp: ImageView = mParentView.findViewById(R.id.action_help) as ImageView
    private var imgTask: SimpleDraweeView = mParentView.findViewById(R.id.img_task) as SimpleDraweeView

    lateinit var mData : TaskItemBean

    init {
        actionTask.setOnClickListener {
            if (!mData.enabled && mData.receive) { // 获取积分
                reqScore()
            } else if (mData.enabled) {
                //跳转各任务
                JumpUtils.jump(mData.jump)
            }
        }

        actionHelp.setOnClickListener {
            PromtDialog(mParentView.context)
                    .setLeftButton(false)
                    .setContent(mData.name + "任务可能会稍有延迟，若任务还未完成，可过5分钟再来领取奖励！")
                    .customLayout()
        }
    }

    private fun notifyUI() {
        if (imgTask.tag == null || TextUtils.isEmpty(imgTask.tag as String)) {
            imgTask.tag = mData.avatar
            ImageUtils.getInstance().load(imgTask, mData.avatar)
        } else {
            if (imgTask.tag as String != mData.avatar) {
                imgTask.tag = mData.avatar
                ImageUtils.getInstance().load(imgTask, mData.avatar)   //加载头像
            }
        }

        txtTaskName.text = mData.name
        txtTaskDes.text = mData.des
        txtTaskProgress.text ="进度 ${mData.process}/${mData.aim}"

        when {
            mData.enabled -> actionTask.setBackgroundResource(R.drawable.ic_cj_task_go)
            mData.receive -> actionTask.setBackgroundResource(R.drawable.ic_cj_task_patch)
            else -> actionTask.setBackgroundResource(R.drawable.ic_cj_task_finish)
        }

        when( mData.id) {
            "16" -> actionHelp.visibility = View.VISIBLE
            "17" -> actionHelp.visibility = View.VISIBLE
            else -> actionHelp.visibility = View.GONE
        }
    }

    override fun setItem(item: Item?) {
        if (item != null) {
            mData = item.obj as TaskItemBean

            notifyUI()
        }
    }

    private fun reqScore() {

        val params = HashMap<String, String>()
        params.put("task_id", mData.id)
        params.put("code", mData.code)
        params.put("task_code", mData.task_code)

        MyRequest.request(mParentView.context, RbEntity.url.TASK_RECEIVE, params, object : IRespondMsg {
            override fun doRequest(tag: Int, vararg objs: Any) {
                TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
            }

            override fun onRequestSuccess(response: RbEntity) {
                val data = response.data as RpdSign

                if ( data.isSuccess) {
                    EventBus.getDefault().post(OgowEvent(OgowEvent.EVENT_CODE_REFRESH_SCORE, data.score))

                    mData.enabled = false
                    mData.receive = false
                    actionTask.setBackgroundResource(R.drawable.ic_cj_task_finish)
                }
            }

            override fun onRequestFail(error: RbEntity) {
                TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
            }


        }, RpdSign::class.java, true)
    }

}