package com.ogow.dialog

import android.content.Context
import android.view.MotionEvent
import android.view.View
import android.view.ViewGroup
import android.view.WindowManager
import com.ogow.activity.R
import com.ogow.libs.dialog.OgowBaseDialog
import kotlinx.android.synthetic.main.process_dialog.*

/**
 * 作者　　: 李坤
 * 创建时间: 2018/12/20　10:30
 * 邮箱　　：496546144@qq.com
 *
 * 功能介绍：图文分享的展示图片生成中
 * 为了让view有一个可以依赖的窗口
 *
 * @param tagerView 需要添加到窗口的view
 */
class SharedImageLoadDialog @JvmOverloads constructor(context: Context, var tagerView: View)
    : OgowBaseDialog(context, R.style.dialog_bg_transparent) {
    companion object {
        const val VIEW_ID = Integer.MAX_VALUE / 3
    }

    fun remove() {
        (window.decorView?.findViewById(android.R.id.content) as ViewGroup?)?.removeView(tagerView)
    }

    override fun getLayoutId() = R.layout.dialog_shared_image_load
    override fun initView() {
        tagerView.id = VIEW_ID
        (window.decorView?.findViewById(android.R.id.content) as ViewGroup?)?.addView(tagerView, 0)
        progressText.text = "图片生成中"
        progressbar.doStart()
    }

    override fun dismiss() {
        progressbar.doStop()
        super.dismiss()
    }

    override fun onTouchEvent(event: MotionEvent?): Boolean {
        dismiss()
        return super.onTouchEvent(event)
    }

    override fun initWindowParams(params: WindowManager.LayoutParams?) {
        super.initWindowParams(params)
    }

    override fun getLayoutWidth(): Int {
        return ViewGroup.LayoutParams.MATCH_PARENT
    }

    override fun getLayoutHeight(): Int {
        return ViewGroup.LayoutParams.WRAP_CONTENT
    }
}