package com.ogow.dialog

import android.content.Context
import android.graphics.drawable.GradientDrawable
import android.view.ViewGroup
import com.ogow.activity.R
import com.ogow.libs.constants.StaticParameters
import com.ashlikun.utils.other.DimensUtils
import com.ogow.libs.utils.ToastUtils
import com.ashlikun.utils.ui.DrawableUtils;
import com.ashlikun.utils.other.SpannableUtils
import com.ogow.libs.dialog.OgowBaseDialog
import kotlinx.android.synthetic.main.dialog_shared_tuwen_result.*

/**
 * 作者　　: 李坤
 * 创建时间: 2018/12/21　13:16
 * 邮箱　　：496546144@qq.com
 *
 * 功能介绍：图文分享的结果对话框
 */
class SharedTuwenResultDialog(context: Context) : OgowBaseDialog(context, R.style.Dialog_Default) {

    override fun getLayoutId() = R.layout.dialog_shared_tuwen_result
    override fun getLayoutWidth(): Int {
        return ViewGroup.LayoutParams.MATCH_PARENT
    }

    override fun initView() {
        rootView.background = DrawableUtils(context).getGradientDrawable(R.color.white, 4f)

        var drawable = GradientDrawable()
        var size = DimensUtils.dip2px(context, 4f)
        drawable.setBounds(0, 0, size, size)
        drawable.setColor(0xfffa5c4f.toInt())
        drawable.cornerRadius = size / 2f
        resultTv.text = SpannableUtils.getBuilder("").setLineSpacingExtra(resultTv.lineSpacingExtra).setDrawable(drawable)
                .append("  文案已复制\n")
                .append("").setDrawable(drawable)
                .append("  分享二维码已保存\n")
                .append("").setDrawable(drawable)
                //最后一个空白行是为了兼容lineSpacingExtra
                .append("  图案已保存到相册\n")
                .create()
        wxActionButton.setOnClickListener {
            if (StaticParameters.api.isWXAppInstalled) {
                StaticParameters.api.openWXApp()
            } else {
                ToastUtils.toastShort("请先安装微信客户端")
            }
            finish()
        }
        closeButton.setOnClickListener {
            finish()
        }
    }
}