package com.ogow.interfaces

import android.text.TextUtils
import com.ashlikun.utils.ApplicationListener
import com.ashlikun.utils.ui.ActivityManager
import com.ashlikun.utils.other.MainHandle
import com.ogow.basic.utils.event.OgowEvent
import com.ogow.constant.GlobelVariable
import com.ogow.core.https.MyRequest
import com.ogow.core.https.entity.RbEntity
import com.ogow.core.https.interfaces.IBaseRespondMsg
import com.ogow.lib.log.OLog
import com.ogow.libs.constants.StaticParameters
import com.ogow.libs.utils.OgowUtils
import com.ogow.libs.utils.ScreenUtil
import com.ogow.request.entity.ShareInfo
import com.ogow.utility.MainUtils
import org.greenrobot.eventbus.EventBus
import java.util.*

/**
 * 作者　　: 李坤
 * 创建时间: 2019/4/30　15:08
 * 邮箱　　：496546144@qq.com
 *
 * 功能介绍：前台太改变
 */
class ForegroundBackgroundChang : ApplicationListener.OnChangListener, IBaseRespondMsg {
    override fun onRequestFail(error: RbEntity) {

    }

    override fun onChang(isForeground: Boolean) {
        if (isForeground) {
            if (ScreenUtil.isFastClick()) {
                return
            }
            if (StaticParameters.IS_ININ) {
                doRequest()
            } else {
                MainHandle.get().postDelayed({ doRequest() }, 3000)
            }
        }
    }

    fun doRequest() {
        val params = HashMap<String, String>()
        params["platform"] = "Android"
        params["platformVersion"] = OgowUtils.getSystemVersion()
        if (TextUtils.isEmpty(GlobelVariable.AppWebKit)) {
            GlobelVariable.AppWebKit = MainUtils.getappleWebKit(ActivityManager.getForegroundActivity())
        }
        params["appleWebkit"] = GlobelVariable.AppWebKit
        params["screenWidth"] = GlobelVariable.WIDTH.toString()
        params["screenHeight"] = GlobelVariable.HEIGHT.toString()
        MyRequest.request(this, RbEntity.TAG.GETUSERSHAREVISIT, RbEntity.url.GETUSERSHAREVISIT, params, this, ShareInfo::class.java, false)
    }

    override fun onRequestSuccess(response: RbEntity) {
        when (response.rbTag) {
            RbEntity.TAG.GETUSERSHAREVISIT -> {
                val mShareInfo = response.data as ShareInfo
                OLog.v("唤醒:///" + response.extra)
                if (mShareInfo != null && mShareInfo.isSuccess) {
                    if (!TextUtils.isEmpty(mShareInfo.appParameter)) {
                        GlobelVariable.SHOW_AD = true
                        MainUtils.webOpen(ActivityManager.getForegroundActivity(), mShareInfo.appParameter)
                        EventBus.getDefault().post(OgowEvent(OgowEvent.EVENT_CODE_WAKEUP_CLOSE_AD))
                    }
                }
            }
        }
    }
}